/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package audiogui;



import java.awt.Color;
import java.awt.Cursor;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.SwingWorker;
import javax.swing.filechooser.FileNameExtensionFilter;


 


/**
 *
 * @author a0273957
 */
public class LoadTest2 extends javax.swing.JFrame implements PropertyChangeListener {
    Communicator communicator = null;
    WavFile wavFile = null;
    File prevDir = null;
    long Length = 0;
    byte[] LengthByte = {0,0,0,0};
    private Task task;

    class Task extends SwingWorker<Void, Void> {
        /*
         * Main task. Executed in background thread.
         */
        @Override
        public Void doInBackground() {
            int size =0;            
            //Initialize progress property.
            int progress = 0;
            setProgress(progress);
            setCursor(Cursor.WAIT_CURSOR);
            byte[] StartAddressByte= {0,0,0};
            size = (int)Length;
            jProgressBar1.setValue(0);
            setProgress(progress);
            //get Start Address -- assumes hex entered
            String StartAddressText = StartAddressField.getText();  //Need to change from ASCII?
            int StartAddress = Integer.parseInt(StartAddressText,16);
            ByteBuffer bb = ByteBuffer.allocate(4);
            bb.putInt(StartAddress);
            byte[] tempStartAddressByte = bb.array();
            StartAddressByte[0] = tempStartAddressByte[1];
            StartAddressByte[1] = tempStartAddressByte[2];
            StartAddressByte[2] = tempStartAddressByte[3];
            int framesRead =0;
            int framesReadTotal =0;
            ///create buffer hold 100 frames
            int[] buffer = new int[100]; //assuming one channel
            int[] buffer2 = new int[2];
            try {
                framesReadTotal = wavFile.readFrames(buffer2, 2); //grabbing first two sets of data
            } catch (IOException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            } catch (WavFileException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            }
                //Need to send length and start address to MSP430 + 2 things of data
                byte[] byteBuf2 = new byte[2];
                byte[] bytebuf100 = new byte[100];
                byteBuf2[0]= (byte) buffer2[0];
                byteBuf2[1]= (byte) buffer2[1];
                byte[] firstcommand = new byte[1];
                firstcommand[0] = 0x55;
                if(EraseCheck.isSelected())
                { 
                    firstcommand[0] =  (byte)0xAA;
                    communicator.writeData(firstcommand);
                }
                else
                {
                    firstcommand[0] =  (byte)0x55;
                    communicator.writeData(firstcommand);
                }
                try {
                //a Pause
                Thread.sleep(100); //Sleep for 100 ms for full erase
            } catch (InterruptedException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            }
                
                communicator.writeData(LengthByte);
                communicator.writeData(StartAddressByte);
                communicator.writeData(byteBuf2);


            try {
                //a Pause
                Thread.sleep(20);
            } catch (InterruptedException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            }

                do
                {
                    
                    if((framesReadTotal +100) > Length)
                    {
                        
                        byte[] tbuff = new byte[((int)Length-framesReadTotal)];
                        try {
                            //load remaining frames -- offset of Total frames read.
                            //framesRead = wavFile.readFrames(buffer, framesReadTotal, 100);
                            framesRead = wavFile.readFrames(buffer,((int)Length-framesReadTotal));
                            
                        } catch (IOException ex) {
                            Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (WavFileException ex) {
                            Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
                        }
                         for ( int i=0; i<((int)Length-framesReadTotal);i++){
                                tbuff[i] = (byte) buffer[i];
                            }
                         framesReadTotal = framesRead + framesReadTotal; //incrmement total
                        //Then Send last data grabbed
                        communicator.writeData(tbuff);
                        progress = (int)((framesReadTotal/(double)size)*100);
                    }
                    else
                    {
                        try {
                            //load 100 frames -- offset of Total frames read.
                            //framesRead = wavFile.readFrames(buffer, framesReadTotal, 100);
                            framesRead = wavFile.readFrames(buffer,100);
                            framesReadTotal = framesRead + framesReadTotal; //incrmement total
                        } catch (IOException ex) {
                            Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (WavFileException ex) {
                            Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
                        }

                            for ( int i=0; i<100;i++){
                                bytebuf100[i] = (byte) buffer[i];
                            }
                        //Then Send last data grabbed
                        communicator.writeData(bytebuf100);
                        progress = (int)((framesReadTotal/(double)size)*100);
                    }
                
                setProgress(progress);

                }
                while (framesReadTotal < Length);
                
                jProgressBar1.setString("DONE.");
            try {
                // close wave file
                wavFile.close();
            } catch (IOException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            }
            return null;
        }

        /*
         * Executed in event dispatching thread
         */
        @Override
        public void done() {
            SendFile.setEnabled(true);
            setCursor(null); //turn off the wait cursor
        }
    }
    
    /**
     * Invoked when task's progress property changes.
     */
    public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().contentEquals("progress")) {
            int progress = (Integer) evt.getNewValue();
            jProgressBar1.setValue(progress);
            jProgressBar1.setString(progress + "%");
        }
    }

     
    /**
     * Creates new form LoadTest2
     */
    public LoadTest2() {
        initComponents();
    }

     /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the F orm Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        WavChooser = new javax.swing.JFileChooser();
        panel11 = new audiogui.Panel1();
        jPanel1 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        SendFile = new javax.swing.JButton();
        Browse = new javax.swing.JButton();
        FileField = new javax.swing.JTextField();
        LoadWav = new javax.swing.JLabel();
        StartAddressField = new javax.swing.JTextField();
        SPIFSA = new javax.swing.JLabel();
        HexPrefix = new javax.swing.JLabel();
        RateLabel = new javax.swing.JLabel();
        LengthLabel = new javax.swing.JLabel();
        RateDisplay = new javax.swing.JTextField();
        LengthDisplay = new javax.swing.JTextField();
        BitLabel = new javax.swing.JLabel();
        BitDisplay = new javax.swing.JTextField();
        EraseCheck = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new GUI();
        communicator = ((GUI)jPanel2).getCommunicator();

        WavChooser.setDialogTitle("this is my open dialog");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Texas Instruments Sound Loader");

        jProgressBar1.setToolTipText("");
        jProgressBar1.setStringPainted(true);
        jProgressBar1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jProgressBar1PropertyChange(evt);
            }
        });

        SendFile.setText("Send File");
        SendFile.setEnabled(false);
        SendFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SendFileActionPerformed(evt);
            }
        });

        Browse.setText("Browse...");
        Browse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BrowseActionPerformed(evt);
            }
        });

        FileField.setEditable(false);
        FileField.setBackground(new java.awt.Color(204, 204, 204));
        FileField.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        FileField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FileFieldActionPerformed(evt);
            }
        });

        LoadWav.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        LoadWav.setText("Load WAV File");

        StartAddressField.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        StartAddressField.setText("000000");
        StartAddressField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StartAddressFieldActionPerformed(evt);
            }
        });

        SPIFSA.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        SPIFSA.setText("SPI Flash Start Address");

        HexPrefix.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        HexPrefix.setText("0x");

        RateLabel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        RateLabel.setText("Sample Rate:");

        LengthLabel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        LengthLabel.setText("Sample Length:");

        RateDisplay.setEditable(false);
        RateDisplay.setBackground(new java.awt.Color(204, 204, 204));

        LengthDisplay.setEditable(false);
        LengthDisplay.setBackground(new java.awt.Color(204, 204, 204));

        BitLabel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        BitLabel.setText("Bit Length:");

        BitDisplay.setEditable(false);
        BitDisplay.setBackground(new java.awt.Color(204, 204, 204));
        BitDisplay.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

        EraseCheck.setText("Erase Flash?");
        EraseCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EraseCheckActionPerformed(evt);
            }
        });

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/audiogui/TI_Logo.jpg"))); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(HexPrefix)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(StartAddressField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(SPIFSA, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(EraseCheck))
                                .addGap(138, 138, 138)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(LengthLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(RateLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(BitLabel, javax.swing.GroupLayout.Alignment.LEADING))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(RateDisplay)
                                    .addComponent(LengthDisplay)
                                    .addComponent(BitDisplay, javax.swing.GroupLayout.DEFAULT_SIZE, 90, Short.MAX_VALUE)))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .addComponent(FileField, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(Browse))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(LoadWav, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(156, 156, 156)))
                                .addGap(139, 139, 139)
                                .addComponent(SendFile)))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(LoadWav, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(FileField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Browse)
                            .addComponent(SendFile))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(BitLabel)
                            .addComponent(BitDisplay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(EraseCheck))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(RateLabel)
                                    .addComponent(RateDisplay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(LengthLabel)
                                    .addComponent(LengthDisplay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addComponent(SPIFSA, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(StartAddressField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(HexPrefix)))))
                    .addComponent(jLabel1))
                .addGap(30, 30, 30)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(28, 28, 28))
        );

        javax.swing.GroupLayout panel11Layout = new javax.swing.GroupLayout(panel11);
        panel11.setLayout(panel11Layout);
        panel11Layout.setHorizontalGroup(
            panel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel11Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panel11Layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        panel11Layout.setVerticalGroup(
            panel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panel11Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(panel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void EraseCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EraseCheckActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_EraseCheckActionPerformed

    private void StartAddressFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StartAddressFieldActionPerformed
        // TODO add your handling code here:
        StartAddressField.selectAll();
    }//GEN-LAST:event_StartAddressFieldActionPerformed

    private void FileFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FileFieldActionPerformed
        // TODO add your handling code here:
        FileField.selectAll();
    }//GEN-LAST:event_FileFieldActionPerformed

    private void BrowseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BrowseActionPerformed
        // TODO add your handling code here:
        JFileChooser test = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "WAV File", "wav");
        test.setFileFilter(filter);
        test.setCurrentDirectory(prevDir);
        int returnVal = test.showOpenDialog(test);
        

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            prevDir = test.getCurrentDirectory();
            File file = test.getSelectedFile();
            FileField.setText(file.getAbsolutePath());
            try {
                // TODO add your handling code here:

                // The name of the file to open.
                String fileName = FileField.getText();
                //Open wav file
                wavFile = WavFile.openWavFile(new File(fileName));

                //Get Wav info
                long sampleRate = wavFile.getSampleRate();
                //int bitResolution = wavFile.getValidBits();
                Length = wavFile.getNumFrames();
                ByteBuffer b = ByteBuffer.allocate(4);
                b.putInt((int)Length);
                LengthByte = b.array();
                int validBits = wavFile.getValidBits();
                //display this information
                if(validBits > 8)
                {
                    BitDisplay.setText("Invalid");
                    BitDisplay.setForeground(Color.red);

                    SendFile.setEnabled(false);
                }
                else
                {
                    BitDisplay.setForeground(Color.BLACK);
                    BitDisplay.setText(Integer.toString(validBits));
                    SendFile.setEnabled(true);
                }
                RateDisplay.setText(Long.toString(sampleRate));
                LengthDisplay.setText(Long.toString(Length));
            } catch (IOException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            } catch (WavFileException ex) {
                Logger.getLogger(LoadTest2.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            System.out.println("File access cancelled by user.");
        }
    }//GEN-LAST:event_BrowseActionPerformed

    private void SendFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SendFileActionPerformed
        SendFile.setEnabled(false);
        task = new Task();
        task.addPropertyChangeListener(this);
        task.execute();
    }//GEN-LAST:event_SendFileActionPerformed

    private void jProgressBar1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jProgressBar1PropertyChange

    }//GEN-LAST:event_jProgressBar1PropertyChange

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(LoadTest2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(LoadTest2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(LoadTest2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(LoadTest2.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LoadTest2().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField BitDisplay;
    private javax.swing.JLabel BitLabel;
    private javax.swing.JButton Browse;
    private javax.swing.JCheckBox EraseCheck;
    private javax.swing.JTextField FileField;
    private javax.swing.JLabel HexPrefix;
    private javax.swing.JTextField LengthDisplay;
    private javax.swing.JLabel LengthLabel;
    private javax.swing.JLabel LoadWav;
    private javax.swing.JTextField RateDisplay;
    private javax.swing.JLabel RateLabel;
    private javax.swing.JLabel SPIFSA;
    private javax.swing.JButton SendFile;
    private javax.swing.JTextField StartAddressField;
    private javax.swing.JFileChooser WavChooser;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JProgressBar jProgressBar1;
    private audiogui.Panel1 panel11;
    // End of variables declaration//GEN-END:variables
}
